#include <stdio.h>

void fail(msg)
char *msg;
{
	fputs(msg, stderr);
	exit(1);
}

int main(argc, argv)
int argc;
char **argv;
{
	FILE *sfile, *listfile, *lastdeltafile;
	int bysid, ser;
	char *sid;
	char line[512];

	if (argc != 5 || argv[2][0] != '-' || argv[2][1] != 'a' && argv[2][1] != 'r')
		fail("mkdeltalist: invalid command line\n");
	if (argv[2][1] == 'a') {
		bysid = 0;
		ser = atoi(argv[2] + 2);
	}
	else {
		bysid = 1;
		sid = argv[2] + 2;
	}

	sfile = fopen(argv[1], "r");
	if (sfile == NULL)
		perror(argv[1]);
	listfile = fopen(argv[3], "w");
	if (listfile == NULL)
		perror(argv[3]);
	lastdeltafile = fopen(argv[4], "w");
	if (lastdeltafile == NULL)
		perror(argv[4]);

	if (fgets(line, 512, sfile) == NULL)
		perror(argv[1]);
	if (line[0] != '\001' || line[1] != 'h')
		fail("invalid SCCS file\n");
	for (;;) {
		char dtype, dsid[24];
		int dser;

		if (fgets(line, 512, sfile) == NULL)
			perror(argv[1]);
		if (line[0] != '\001' || line[1] != 's')
			fail("invalid SCCS file\n");
		if (fgets(line, 512, sfile) == NULL)
			perror(argv[1]);
		if (sscanf(line, "\001d %c %s %*s %*s %*s %d", &dtype, dsid, &dser) < 3)
			fail("invalid SCCS file\n");
		if (!bysid) {
			if (ser == dser)
				break;
		}
		else {
			if (dtype == 'D' && !strcmp(sid, dsid)) {
				ser = dser;
				break;
			}
		}
		if (dtype == 'D')
			fprintf(listfile, "%s\n", dsid);
		for (;;) {
			if (fgets(line, 512, sfile) == NULL)
				perror(argv[1]);
			if (line[0] == '\001' && line[1] == 'e')
				break;
		}
	}
	fprintf(lastdeltafile, "%d\n", ser);

	fclose(sfile);
	fclose(listfile);
	fclose(lastdeltafile);
	return 0;
}
